PRAGMA foreign_keys = ON;

DROP TABLE IF EXISTS USER;
CREATE TABLE USER(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	EMAIL TEXT NOT NULL UNIQUE,
	PASSWORD TEXT NOT NULL,
	ROLE TEXT NOT NULL
);


DROP TABLE IF EXISTS PASSENGER;
CREATE TABLE PASSENGER(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL,
	DISPLAY_NAME TEXT NOT NULL,
	EMAIL TEXT NOT NULL UNIQUE,
	UNI_ID INTEGER NOT NULL,
	COM_ID INTEGER NOT NULL,
	PHOTO TEXT,
	INFO TEXT,
	USER_ID INTEGER,
	FOREIGN KEY(UNI_ID) REFERENCES UNIVERSITY(ID),
	FOREIGN KEY(COM_ID) REFERENCES COMMUNITY(ID),
	FOREIGN KEY(USER_ID) REFERENCES USER(ID)
);



DROP TABLE IF EXISTS DRIVER;
CREATE TABLE DRIVER(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL,
	DISPLAY_NAME TEXT NOT NULL,
	EMAIL TEXT NOT NULL UNIQUE,
	REG_NO TEXT NOT NULL UNIQUE,
	TAXI_NO TEXT NOT NULL UNIQUE,
	PHOTO TEXT,
	INFO TEXT,
	USER_ID INTEGER,
	FOREIGN KEY(USER_ID) REFERENCES USER(ID)
);


DROP TABLE IF EXISTS COMPANY;
CREATE TABLE COMPANY(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL,
	EMAIL TEXT NOT NULL UNIQUE,
	REG_NO TEXT NOT NULL UNIQUE,
	LOGO TEXT,
	INFO TEXT,
	USER_ID INTEGER,
	FOREIGN KEY(USER_ID) REFERENCES USER(ID)
);


DROP TABLE IF EXISTS UNIVERSITY;
CREATE TABLE UNIVERSITY(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL UNIQUE,
	EMAIL_EXT TEXT NOT NULL
);


DROP TABLE IF EXISTS COMMUNITY;
CREATE TABLE COMMUNITY(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL,
	UNI_ID TEXT NOT NULL,
	FOREIGN KEY(UNI_ID) REFERENCES UNIVERSITY(ID)
);


DROP TABLE IF EXISTS LOCATION;
CREATE TABLE LOCATION(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	NAME TEXT NOT NULL UNIQUE
);


DROP TABLE IF EXISTS RIDE;
CREATE TABLE RIDE(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	CREATOR_ID INTEGER NOT NULL,
	START_LOC_ID INTEGER NOT NULL,
	END_LOC_ID INTEGER NOT NULL,
	TIME DATETIME NOT NULL,
	PASS_REQUIRED INTEGER NOT NULL DEFAULT 0,
	PASS_ON_BOARD INTEGER NOT NULL DEFAULT 0,
	DRIVER_ID INTEGER,
	ACTIVE CHAR(1) NOT NULL DEFAULT '1',
	COMPLETE DATETIME,
	FOREIGN KEY(CREATOR_ID) REFERENCES PASSENGER(ID),
	FOREIGN KEY(START_LOC_ID) REFERENCES LOCATION(ID),
	FOREIGN KEY(END_LOC_ID) REFERENCES LOCATION(ID),
	FOREIGN KEY(DRIVER_ID) REFERENCES DRIVER(ID)
);


DROP TABLE IF EXISTS INVITATION;
CREATE TABLE INVITATION(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	CREATOR_ID INTEGER NOT NULL,
	RECEIVER_ID INTEGER NOT NULL,
	START_LOC_ID INTEGER NOT NULL,
	END_LOC_ID INTEGER NOT NULL,
	TIME DATETIME NOT NULL,
	ACCEPT CHAR(1) NOT NULL DEFAULT '0',
	CREATED DATETIME NOT NULL,
	FOREIGN KEY(CREATOR_ID) REFERENCES PASSENGER(ID),
	FOREIGN KEY(RECEIVER_ID) REFERENCES PASSENGER(ID),
	FOREIGN KEY(START_LOC_ID) REFERENCES LOCATION(ID),
	FOREIGN KEY(END_LOC_ID) REFERENCES LOCATION(ID)
);


DROP TABLE IF EXISTS RIDE_LOG;
CREATE TABLE RIDE_LOG(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	RIDE_ID INTEGER NOT NULL,
	PASS_ID INTEGER NOT NULL,
	FOREIGN KEY(RIDE_ID) REFERENCES RIDE(ID),
	FOREIGN KEY(PASS_ID) REFERENCES PASSENGER(ID)
);


DROP TABLE IF EXISTS RIDE_APPLY_PASSENGER;
CREATE TABLE RIDE_APPLY_PASSENGER(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	RIDE_ID INTEGER NOT NULL,
	PASS_ID INTEGER NOT NULL,
	FOREIGN KEY(RIDE_ID) REFERENCES RIDE(ID),
	FOREIGN KEY(PASS_ID) REFERENCES PASSENGER(ID)
);


DROP TABLE IF EXISTS RIDE_APPLY_DRIVER;
CREATE TABLE RIDE_APPLY_DRIVER(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	RIDE_ID INTEGER NOT NULL,
	DRIVER_ID INTEGER NOT NULL,
	FOREIGN KEY(RIDE_ID) REFERENCES RIDE(ID),
	FOREIGN KEY(DRIVER_ID) REFERENCES DRIVER(ID)
);


DROP TABLE IF EXISTS NOTIFICATION;
CREATE TABLE NOTIFICATION(
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	USER_ID INTEGER NOT NULL REFERENCES USER(ID),
	BODY TEXT NOT NULL,
	FOREIGN KEY(USER_ID) REFERENCES USER(ID)
);
